package java.util.zip;

import java.security.AccessController;
import sun.security.action.LoadLibraryAction;

public class Adler32 implements Checksum {
   private int adler = 1;

   public void update(int var1) {
      this.adler = update(this.adler, var1);
   }

   public void update(byte[] var1, int var2, int var3) {
      if (var1 == null) {
         throw new NullPointerException();
      } else if (var2 >= 0 && var3 >= 0 && var2 + var3 <= var1.length) {
         this.adler = updateBytes(this.adler, var1, var2, var3);
      } else {
         throw new ArrayIndexOutOfBoundsException();
      }
   }

   public void update(byte[] var1) {
      this.adler = updateBytes(this.adler, var1, 0, var1.length);
   }

   public void reset() {
      this.adler = 1;
   }

   public long getValue() {
      return (long)this.adler & 4294967295L;
   }

   private static native int update(int var0, int var1);

   private static native int updateBytes(int var0, byte[] var1, int var2, int var3);

   static {
      AccessController.doPrivileged(new LoadLibraryAction("zip"));
   }
}
